/************************************************************************
 *
 *			ob|rdqud
 *
 *				: caʃTu[`
 *		t@C	: dbsub.c
 *		쐬		: s.aizawa
 *
 ************************************************************************/

#include "pcsos.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#define	iskanji(c)	((c) & 0x80)
#include "pcsdef.h"
#include "pcsdb.h"
#include "pcsdbsub.h"
#include "pcscom.h"

/*=======================================================================
 |
 |		L[o
 |
 |	SHORT	GetKey(dp, rbp, ihp, kp)
 |
 |		DBF	*dp;		cae|C^
 |		CHAR	*rbp;		R[hobt@|C^
 |		IDX_H	*ihp;		hcwQg|C^
 |		VOID	*kp;		L[obt@
 |
 |		Ԓl			OFL[Ȃ@PFL[
 |
 =======================================================================*/
SHORT	GetKey(DBF *dp, CHAR *rbp, IDX_H *ihp, VOID *kp)
{
	FIELD	*flp;
	CHAR	buf[100], *p;
	SHORT	flag;

	strcpy(buf, ihp->index);
	p = strtok(buf, "+ ");
	switch (ihp->type) {
	case KEY_TYPE_C:
		*(CHAR *)kp = '\0';
		break;
	case KEY_TYPE_N:
		*(double *)kp = 0;
		break;
	case KEY_TYPE_I:
		*(LONG *)kp = 0L;
		break;
	default:
		return 0;
	}

	flag = 0;
	while (p) {
		if ((flp = GetField(dp, p)) != NULL) {
			switch (ihp->type) {
			case KEY_TYPE_C:
				memcpy(kp, &rbp[flp->offset], flp->lField2);
				(CHAR *)kp += flp->lField2;
				break;
			case KEY_TYPE_N:
				*(double *)kp += natof(&rbp[flp->offset],
								flp->lField2);
				break;
			case KEY_TYPE_I:
				*(LONG *)kp += natol(&rbp[flp->offset],
								flp->lField2);
				break;
			}
			flag = 1;
		} else
			return 0;

		p = strtok(NULL, "+ ");
	}

	return flag;
}

/*=======================================================================
 |
 |		tB[h|C^o
 |
 |	FIELD	*GetField(dp, field)
 |
 |		DBF	*dp;		cae|C^
 |		CHAR	*field;		tB[h
 |
 |		Ԓl			tB[hւ̃|C^
 |
 =======================================================================*/
FIELD	*GetField(DBF *dp, CHAR *field)
{
	SHORT	i;
	FIELD	*flp;
	CHAR	buf[11], *p;

	strcpy(buf, field);
	for (p = buf; *p; p++) {
		if (iskanji(*p)) {
			if (*(++p) == '\0')
				break;
		} else if (islower(*p))
			*p -= 0x20;
	}

	for (i = 0, flp = dp->flp; i < dp->nField; i++, flp++) {
		if (strcmp(buf, flp->name) == 0)
			return flp;
	}
	return NULL;
}

/*=======================================================================
 |
 |		tB[hԍo
 |
 |	SHORT	GetField(dp, field)
 |
 |		DBF	*dp;		cae|C^
 |		CHAR	*field;		tB[h
 |
 |		Ԓl			tB[hԍ
 |
 =======================================================================*/
SHORT	GetFieldNo(DBF *dp, CHAR *field)
{
	SHORT	i;
	FIELD	*flp;
	CHAR	buf[11], *p;

	strcpy(buf, field);
	for (p = buf; *p; p++) {
		if (iskanji(*p))
			p++;
		else if (islower(*p))
			*p -= 0x20;
	}

	for (i = 0, flp = dp->flp; i < dp->nField; i++, flp++) {
		if (strcmp(buf, flp->name) == 0)
			return i;
	}
	return -1;
}
